"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
var waitMap_1 = require("rxjs-operators/lib/waitMap");
var diagnostic_1 = require("../handles/diagnostic");
var workspaces_1 = require("./workspaces");
var util_1 = require("../common/util");
var scan_1 = require("./scan");
var parserHandles = {};
var origin$ = new rxjs_1.Subject();
function next(textDoc, con) {
    if (!parserHandles[textDoc.uri]) {
        var languageId_1 = textDoc.languageId, uri_1 = textDoc.uri;
        parserHandles[uri_1] = origin$.pipe(operators_1.filter(function (textDoc) { return uri_1 === textDoc.uri; }), operators_1.switchMap(function (textDoc) {
            return rxjs_1.timer(100).pipe(operators_1.map(function () { return textDoc; }));
        }), waitMap_1.waitMap(function (textDoc) {
            return rxjs_1.from(util_1.handleParse(textDoc));
        }, true)).subscribe(function (res) {
            // handle diagnostic
            diagnostic_1.handleDiagnostic(textDoc, res[1]);
            // handle node
            workspaces_1.workspace.updateBuffer(uri_1, res[0]);
            // scan project
            scan_1.scan(uri_1);
        }, function (err) {
            con.console.error("[" + languageId_1 + "]: parse buffer error: " + err.message);
        });
    }
    origin$.next(textDoc);
}
exports.next = next;
function unsubscribe(textDoc) {
    if (parserHandles[textDoc.uri] !== undefined) {
        parserHandles[textDoc.uri].unsubscribe();
    }
    parserHandles[textDoc.uri] = undefined;
}
exports.unsubscribe = unsubscribe;
//# sourceMappingURL=parser.js.map