"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var os_1 = tslib_1.__importDefault(require("os"));
var rxjs_1 = require("rxjs");
var fast_glob_1 = tslib_1.__importDefault(require("fast-glob"));
var path_1 = require("path");
var operators_1 = require("rxjs/operators");
var vscode_uri_1 = tslib_1.__importDefault(require("vscode-uri"));
var fs_1 = require("fs");
var logger_1 = tslib_1.__importDefault(require("../common/logger"));
var workspaces_1 = require("./workspaces");
var util_1 = require("../common/util");
var constant_1 = require("../common/constant");
var log = logger_1.default('scan');
var handScans = {};
function scan(uri) {
    return tslib_1.__awaiter(this, void 0, void 0, function () {
        var workDir;
        return tslib_1.__generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, util_1.findWorkDirectory(vscode_uri_1.default.parse(uri).fsPath, constant_1.workDirPatterns)];
                case 1:
                    workDir = _a.sent();
                    if (!workDir || workDir === os_1.default.homedir()) {
                        return [2 /*return*/];
                    }
                    if (!handScans[workDir]) {
                        handScans[workDir] = rxjs_1.from(fast_glob_1.default([path_1.join(workDir, '**/*.vim'), '!**/node_modules/**'])).pipe(operators_1.filter(function (list) { return list && list.length > 0; }), operators_1.switchMap(function (list) {
                            return rxjs_1.of.apply(void 0, list);
                        }), operators_1.mergeMap(function (fpath) {
                            var content = fs_1.readFileSync(fpath).toString();
                            return rxjs_1.from(util_1.handleParse(content)).pipe(operators_1.filter(function (res) { return res[0] !== null; }), operators_1.map(function (res) { return ({
                                node: res[0],
                                uri: vscode_uri_1.default.file(fpath).toString()
                            }); }), operators_1.catchError(function (error) {
                                log.error(fpath + ":\n" + (error.stack || error.message || error));
                                return rxjs_1.of(undefined);
                            }));
                        }, 3)).subscribe(function (res) {
                            if (res) {
                                workspaces_1.workspace.updateBuffer(res.uri, res.node);
                            }
                        }, function (error) {
                            log.error(error.stack || error.message || error);
                        });
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.scan = scan;
//# sourceMappingURL=scan.js.map